/* handle.c generated by valac 0.40.19, the Vala compiler
 * generated from handle.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2011-2016 Peng Huang <shawn.p.huang@gmail.com>
 * Copyright(c) 2016-2017 Takao Fujiwara <takao.fujiwara1@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 * USA
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define TYPE_HANDLE (handle_get_type ())
#define HANDLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HANDLE, Handle))
#define HANDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HANDLE, HandleClass))
#define IS_HANDLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HANDLE))
#define IS_HANDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HANDLE))
#define HANDLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HANDLE, HandleClass))

typedef struct _Handle Handle;
typedef struct _HandleClass HandleClass;
typedef struct _HandlePrivate HandlePrivate;
enum  {
	HANDLE_0_PROPERTY,
	HANDLE_NUM_PROPERTIES
};
static GParamSpec* handle_properties[HANDLE_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	HANDLE_MOVE_BEGIN_SIGNAL,
	HANDLE_MOVE_END_SIGNAL,
	HANDLE_NUM_SIGNALS
};
static guint handle_signals[HANDLE_NUM_SIGNALS] = {0};

struct _Handle {
	GtkEventBox parent_instance;
	HandlePrivate * priv;
};

struct _HandleClass {
	GtkEventBoxClass parent_class;
};

struct _HandlePrivate {
	gboolean m_move_begined;
	GdkRectangle m_workarea;
	GdkPoint m_press_pos;
};


static gpointer handle_parent_class = NULL;

GType handle_get_type (void) G_GNUC_CONST;
#define HANDLE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_HANDLE, HandlePrivate))
Handle* handle_new (void);
Handle* handle_construct (GType object_type);
static void handle_real_realize (GtkWidget* base);
static gboolean handle_real_button_press_event (GtkWidget* base,
                                         GdkEventButton* event);
static gboolean handle_real_button_release_event (GtkWidget* base,
                                           GdkEventButton* event);
static gboolean handle_real_motion_notify_event (GtkWidget* base,
                                          GdkEventMotion* event);
static gboolean handle_real_draw (GtkWidget* base,
                           cairo_t* cr);
static void handle_finalize (GObject * obj);


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


Handle*
handle_construct (GType object_type)
{
	Handle * self = NULL;
	GdkEventMask mask = 0U;
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp0_;
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp3_;
	GtkStyleContext* _tmp4_;
	GError* _inner_error0_ = NULL;
	self = (Handle*) g_object_new (object_type, "name", "IBusHandle", NULL);
	gtk_widget_set_size_request ((GtkWidget*) self, 6, -1);
	mask = ((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_BUTTON1_MOTION_MASK;
	gtk_widget_set_events ((GtkWidget*) self, (gint) mask);
	self->priv->m_move_begined = FALSE;
	_tmp0_ = gtk_css_provider_new ();
	css_provider = _tmp0_;
	{
		gtk_css_provider_load_from_data (css_provider, "#IBusHandle { background-color: gray }", (gssize) -1, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = _error_;
		_tmp2_ = _tmp1_->message;
		g_warning ("handle.vala:53: Parse error in Handle: %s", _tmp2_);
		_g_error_free0 (_error_);
	}
	__finally2:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (css_provider);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp4_ = _g_object_ref0 (_tmp3_);
	context = _tmp4_;
	gtk_style_context_add_provider (context, (GtkStyleProvider*) css_provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_g_object_unref0 (context);
	_g_object_unref0 (css_provider);
	return self;
}


Handle*
handle_new (void)
{
	return handle_construct (TYPE_HANDLE);
}


static void
handle_real_realize (GtkWidget* base)
{
	Handle * self;
	self = (Handle*) base;
	GTK_WIDGET_CLASS (handle_parent_class)->realize ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_event_box_get_type (), GtkEventBox));
}


static gboolean
handle_real_button_press_event (GtkWidget* base,
                                GdkEventButton* event)
{
	Handle * self;
	gboolean result = FALSE;
	guint _tmp0_;
	GdkRectangle _tmp1_ = {0};
	gint x = 0;
	gint y = 0;
	GtkWindow* toplevel = NULL;
	GtkWidget* _tmp98_;
	GtkWindow* _tmp99_;
	GtkWindow* _tmp100_;
	gint _tmp101_ = 0;
	gint _tmp102_ = 0;
	gdouble _tmp103_;
	gint _tmp104_;
	gdouble _tmp105_;
	gint _tmp106_;
	self = (Handle*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event->button;
	if (_tmp0_ != ((guint) 1)) {
		result = FALSE;
		return result;
	}
	memset (&_tmp1_, 0, sizeof (GdkRectangle));
	_tmp1_.x = 0;
	_tmp1_.y = 0;
	_tmp1_.width = G_MAXINT;
	_tmp1_.height = G_MAXINT;
	self->priv->m_workarea = _tmp1_;
	{
		gboolean _tmp2_ = FALSE;
		_tmp2_ = TRUE;
		while (TRUE) {
			GdkWindow* root = NULL;
			GdkWindow* _tmp3_;
			GdkWindow* _tmp4_;
			GdkAtom property = 0U;
			GdkAtom type = 0U;
			GdkAtom actual_type = 0U;
			gint format = 0;
			guchar* data = NULL;
			gint data_length1 = 0;
			gint _data_size_ = 0;
			gboolean _result_ = FALSE;
			GdkWindow* _tmp5_;
			GdkAtom _tmp6_;
			GdkAtom _tmp7_;
			GdkAtom _tmp8_ = 0U;
			gint _tmp9_ = 0;
			guint8* _tmp10_ = NULL;
			gint _tmp11_;
			gboolean _tmp12_;
			gboolean _tmp13_ = FALSE;
			gboolean _tmp14_ = FALSE;
			gboolean _tmp15_ = FALSE;
			gboolean _tmp16_;
			gint index = 0;
			guchar* _tmp21_;
			gint _tmp21__length1;
			guchar _tmp22_;
			guchar* _tmp23_;
			gint _tmp23__length1;
			guchar _tmp24_;
			guchar* _tmp25_;
			gint _tmp25__length1;
			guchar _tmp26_;
			guchar* _tmp27_;
			gint _tmp27__length1;
			guchar _tmp28_;
			GdkWindow* _tmp29_;
			GdkAtom _tmp30_;
			GdkAtom _tmp31_;
			GdkAtom _tmp32_ = 0U;
			gint _tmp33_ = 0;
			guint8* _tmp34_ = NULL;
			gint _tmp35_;
			gboolean _tmp36_;
			gboolean _tmp37_ = FALSE;
			gboolean _tmp38_ = FALSE;
			gboolean _tmp39_ = FALSE;
			gboolean _tmp40_;
			gint i = 0;
			gint _tmp46_;
			guchar* _tmp47_;
			gint _tmp47__length1;
			gint _tmp48_;
			guchar _tmp49_;
			guchar* _tmp50_;
			gint _tmp50__length1;
			gint _tmp51_;
			guchar _tmp52_;
			guchar* _tmp53_;
			gint _tmp53__length1;
			gint _tmp54_;
			guchar _tmp55_;
			guchar* _tmp56_;
			gint _tmp56__length1;
			gint _tmp57_;
			guchar _tmp58_;
			gint _tmp59_;
			guchar* _tmp60_;
			gint _tmp60__length1;
			gint _tmp61_;
			guchar _tmp62_;
			guchar* _tmp63_;
			gint _tmp63__length1;
			gint _tmp64_;
			guchar _tmp65_;
			guchar* _tmp66_;
			gint _tmp66__length1;
			gint _tmp67_;
			guchar _tmp68_;
			guchar* _tmp69_;
			gint _tmp69__length1;
			gint _tmp70_;
			guchar _tmp71_;
			gint _tmp72_;
			guchar* _tmp73_;
			gint _tmp73__length1;
			gint _tmp74_;
			guchar _tmp75_;
			guchar* _tmp76_;
			gint _tmp76__length1;
			gint _tmp77_;
			guchar _tmp78_;
			guchar* _tmp79_;
			gint _tmp79__length1;
			gint _tmp80_;
			guchar _tmp81_;
			guchar* _tmp82_;
			gint _tmp82__length1;
			gint _tmp83_;
			guchar _tmp84_;
			gint _tmp85_;
			guchar* _tmp86_;
			gint _tmp86__length1;
			gint _tmp87_;
			guchar _tmp88_;
			guchar* _tmp89_;
			gint _tmp89__length1;
			gint _tmp90_;
			guchar _tmp91_;
			guchar* _tmp92_;
			gint _tmp92__length1;
			gint _tmp93_;
			guchar _tmp94_;
			guchar* _tmp95_;
			gint _tmp95__length1;
			gint _tmp96_;
			guchar _tmp97_;
			if (!_tmp2_) {
				if (!FALSE) {
					break;
				}
			}
			_tmp2_ = FALSE;
			_tmp3_ = gdk_get_default_root_window ();
			_tmp4_ = _g_object_ref0 (_tmp3_);
			root = _tmp4_;
			property = gdk_atom_intern ("_NET_CURRENT_DESKTOP", FALSE);
			type = gdk_atom_intern ("CARDINAL", FALSE);
			_tmp5_ = root;
			_tmp6_ = property;
			_tmp7_ = type;
			_tmp12_ = gdk_property_get (_tmp5_, _tmp6_, _tmp7_, (gulong) 0, (gulong) G_MAXLONG, 0, &_tmp8_, &_tmp9_, &_tmp11_, &_tmp10_);
			actual_type = _tmp8_;
			format = _tmp9_;
			data = (g_free (data), NULL);
			data = _tmp10_;
			data_length1 = _tmp11_;
			_data_size_ = data_length1;
			_result_ = _tmp12_;
			_tmp16_ = _result_;
			if (!_tmp16_) {
				_tmp15_ = TRUE;
			} else {
				GdkAtom _tmp17_;
				GdkAtom _tmp18_;
				_tmp17_ = actual_type;
				_tmp18_ = type;
				_tmp15_ = _tmp17_ != _tmp18_;
			}
			if (_tmp15_) {
				_tmp14_ = TRUE;
			} else {
				gint _tmp19_;
				_tmp19_ = format;
				_tmp14_ = _tmp19_ != 32;
			}
			if (_tmp14_) {
				_tmp13_ = TRUE;
			} else {
				guchar* _tmp20_;
				gint _tmp20__length1;
				_tmp20_ = data;
				_tmp20__length1 = data_length1;
				_tmp13_ = _tmp20__length1 != 4;
			}
			if (_tmp13_) {
				data = (g_free (data), NULL);
				_g_object_unref0 (root);
				break;
			}
			_tmp21_ = data;
			_tmp21__length1 = data_length1;
			_tmp22_ = _tmp21_[0];
			_tmp23_ = data;
			_tmp23__length1 = data_length1;
			_tmp24_ = _tmp23_[1];
			_tmp25_ = data;
			_tmp25__length1 = data_length1;
			_tmp26_ = _tmp25_[2];
			_tmp27_ = data;
			_tmp27__length1 = data_length1;
			_tmp28_ = _tmp27_[3];
			index = (gint) (((_tmp22_ | (_tmp24_ << 8)) | (_tmp26_ << 16)) | (_tmp28_ << 24));
			property = gdk_atom_intern ("_NET_WORKAREA", FALSE);
			type = gdk_atom_intern ("CARDINAL", FALSE);
			_tmp29_ = root;
			_tmp30_ = property;
			_tmp31_ = type;
			_tmp36_ = gdk_property_get (_tmp29_, _tmp30_, _tmp31_, (gulong) 0, (gulong) G_MAXLONG, 0, &_tmp32_, &_tmp33_, &_tmp35_, &_tmp34_);
			actual_type = _tmp32_;
			format = _tmp33_;
			data = (g_free (data), NULL);
			data = _tmp34_;
			data_length1 = _tmp35_;
			_data_size_ = data_length1;
			_result_ = _tmp36_;
			_tmp40_ = _result_;
			if (!_tmp40_) {
				_tmp39_ = TRUE;
			} else {
				GdkAtom _tmp41_;
				GdkAtom _tmp42_;
				_tmp41_ = actual_type;
				_tmp42_ = type;
				_tmp39_ = _tmp41_ != _tmp42_;
			}
			if (_tmp39_) {
				_tmp38_ = TRUE;
			} else {
				gint _tmp43_;
				_tmp43_ = format;
				_tmp38_ = _tmp43_ != 32;
			}
			if (_tmp38_) {
				_tmp37_ = TRUE;
			} else {
				guchar* _tmp44_;
				gint _tmp44__length1;
				gint _tmp45_;
				_tmp44_ = data;
				_tmp44__length1 = data_length1;
				_tmp45_ = index;
				_tmp37_ = _tmp44__length1 < ((_tmp45_ + 1) * 16);
			}
			if (_tmp37_) {
				data = (g_free (data), NULL);
				_g_object_unref0 (root);
				break;
			}
			_tmp46_ = index;
			i = (_tmp46_ * 4) * 4;
			_tmp47_ = data;
			_tmp47__length1 = data_length1;
			_tmp48_ = i;
			_tmp49_ = _tmp47_[_tmp48_];
			_tmp50_ = data;
			_tmp50__length1 = data_length1;
			_tmp51_ = i;
			_tmp52_ = _tmp50_[_tmp51_ + 1];
			_tmp53_ = data;
			_tmp53__length1 = data_length1;
			_tmp54_ = i;
			_tmp55_ = _tmp53_[_tmp54_ + 2];
			_tmp56_ = data;
			_tmp56__length1 = data_length1;
			_tmp57_ = i;
			_tmp58_ = _tmp56_[_tmp57_ + 3];
			self->priv->m_workarea.x = (gint) (((_tmp49_ | (_tmp52_ << 8)) | (_tmp55_ << 16)) | (_tmp58_ << 24));
			_tmp59_ = i;
			i = _tmp59_ + 4;
			_tmp60_ = data;
			_tmp60__length1 = data_length1;
			_tmp61_ = i;
			_tmp62_ = _tmp60_[_tmp61_];
			_tmp63_ = data;
			_tmp63__length1 = data_length1;
			_tmp64_ = i;
			_tmp65_ = _tmp63_[_tmp64_ + 1];
			_tmp66_ = data;
			_tmp66__length1 = data_length1;
			_tmp67_ = i;
			_tmp68_ = _tmp66_[_tmp67_ + 2];
			_tmp69_ = data;
			_tmp69__length1 = data_length1;
			_tmp70_ = i;
			_tmp71_ = _tmp69_[_tmp70_ + 3];
			self->priv->m_workarea.y = (gint) (((_tmp62_ | (_tmp65_ << 8)) | (_tmp68_ << 16)) | (_tmp71_ << 24));
			_tmp72_ = i;
			i = _tmp72_ + 4;
			_tmp73_ = data;
			_tmp73__length1 = data_length1;
			_tmp74_ = i;
			_tmp75_ = _tmp73_[_tmp74_];
			_tmp76_ = data;
			_tmp76__length1 = data_length1;
			_tmp77_ = i;
			_tmp78_ = _tmp76_[_tmp77_ + 1];
			_tmp79_ = data;
			_tmp79__length1 = data_length1;
			_tmp80_ = i;
			_tmp81_ = _tmp79_[_tmp80_ + 2];
			_tmp82_ = data;
			_tmp82__length1 = data_length1;
			_tmp83_ = i;
			_tmp84_ = _tmp82_[_tmp83_ + 3];
			self->priv->m_workarea.width = (gint) (((_tmp75_ | (_tmp78_ << 8)) | (_tmp81_ << 16)) | (_tmp84_ << 24));
			_tmp85_ = i;
			i = _tmp85_ + 4;
			_tmp86_ = data;
			_tmp86__length1 = data_length1;
			_tmp87_ = i;
			_tmp88_ = _tmp86_[_tmp87_];
			_tmp89_ = data;
			_tmp89__length1 = data_length1;
			_tmp90_ = i;
			_tmp91_ = _tmp89_[_tmp90_ + 1];
			_tmp92_ = data;
			_tmp92__length1 = data_length1;
			_tmp93_ = i;
			_tmp94_ = _tmp92_[_tmp93_ + 2];
			_tmp95_ = data;
			_tmp95__length1 = data_length1;
			_tmp96_ = i;
			_tmp97_ = _tmp95_[_tmp96_ + 3];
			self->priv->m_workarea.height = (gint) (((_tmp88_ | (_tmp91_ << 8)) | (_tmp94_ << 16)) | (_tmp97_ << 24));
			data = (g_free (data), NULL);
			_g_object_unref0 (root);
		}
	}
	self->priv->m_move_begined = TRUE;
	_tmp98_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	_tmp99_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp98_, gtk_window_get_type (), GtkWindow));
	toplevel = _tmp99_;
	_tmp100_ = toplevel;
	gtk_window_get_position (_tmp100_, &_tmp101_, &_tmp102_);
	x = _tmp101_;
	y = _tmp102_;
	_tmp103_ = event->x_root;
	_tmp104_ = x;
	self->priv->m_press_pos.x = ((gint) _tmp103_) - _tmp104_;
	_tmp105_ = event->y_root;
	_tmp106_ = y;
	self->priv->m_press_pos.y = ((gint) _tmp105_) - _tmp106_;
	g_signal_emit (self, handle_signals[HANDLE_MOVE_BEGIN_SIGNAL], 0);
	result = TRUE;
	_g_object_unref0 (toplevel);
	return result;
}


static gboolean
handle_real_button_release_event (GtkWidget* base,
                                  GdkEventButton* event)
{
	Handle * self;
	gboolean result = FALSE;
	guint _tmp0_;
	GdkWindow* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkCursor* _tmp3_;
	GdkCursor* _tmp4_;
	self = (Handle*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event->button;
	if (_tmp0_ != ((guint) 1)) {
		result = FALSE;
		return result;
	}
	self->priv->m_move_begined = FALSE;
	self->priv->m_press_pos.x = 0;
	self->priv->m_press_pos.y = 0;
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp2_ = gdk_display_get_default ();
	_tmp3_ = gdk_cursor_new_for_display (_tmp2_, GDK_FLEUR);
	_tmp4_ = _tmp3_;
	gdk_window_set_cursor (_tmp1_, _tmp4_);
	_g_object_unref0 (_tmp4_);
	g_signal_emit (self, handle_signals[HANDLE_MOVE_END_SIGNAL], 0);
	result = TRUE;
	return result;
}


static gboolean
handle_real_motion_notify_event (GtkWidget* base,
                                 GdkEventMotion* event)
{
	Handle * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	GtkWindow* toplevel = NULL;
	GtkWidget* _tmp1_;
	GtkWindow* _tmp2_;
	gint x = 0;
	gdouble _tmp3_;
	GdkPoint _tmp4_;
	gint _tmp5_;
	gint y = 0;
	gdouble _tmp6_;
	GdkPoint _tmp7_;
	gint _tmp8_;
	gboolean _tmp9_ = FALSE;
	gint _tmp10_;
	GdkRectangle _tmp11_;
	gint _tmp12_;
	gboolean _tmp18_ = FALSE;
	gint _tmp19_;
	GdkRectangle _tmp20_;
	gint _tmp21_;
	gint w = 0;
	gint h = 0;
	GtkWindow* _tmp27_;
	gint _tmp28_ = 0;
	gint _tmp29_ = 0;
	gboolean _tmp30_ = FALSE;
	gint _tmp31_;
	gint _tmp32_;
	GdkRectangle _tmp33_;
	gint _tmp34_;
	GdkRectangle _tmp35_;
	gint _tmp36_;
	gboolean _tmp48_ = FALSE;
	gint _tmp49_;
	gint _tmp50_;
	GdkRectangle _tmp51_;
	gint _tmp52_;
	GdkRectangle _tmp53_;
	gint _tmp54_;
	GtkWindow* _tmp66_;
	gint _tmp67_;
	gint _tmp68_;
	self = (Handle*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->m_move_begined;
	if (!_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp1_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_window_get_type (), GtkWindow));
	toplevel = _tmp2_;
	_tmp3_ = event->x_root;
	_tmp4_ = self->priv->m_press_pos;
	_tmp5_ = _tmp4_.x;
	x = (gint) (_tmp3_ - _tmp5_);
	_tmp6_ = event->y_root;
	_tmp7_ = self->priv->m_press_pos;
	_tmp8_ = _tmp7_.y;
	y = (gint) (_tmp6_ - _tmp8_);
	_tmp10_ = x;
	_tmp11_ = self->priv->m_workarea;
	_tmp12_ = _tmp11_.x;
	if (_tmp10_ < _tmp12_) {
		gint _tmp13_;
		GdkRectangle _tmp14_;
		gint _tmp15_;
		_tmp13_ = x;
		_tmp14_ = self->priv->m_workarea;
		_tmp15_ = _tmp14_.x;
		_tmp9_ = _tmp13_ > (_tmp15_ - 16);
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		GdkRectangle _tmp16_;
		gint _tmp17_;
		_tmp16_ = self->priv->m_workarea;
		_tmp17_ = _tmp16_.x;
		x = _tmp17_;
	}
	_tmp19_ = y;
	_tmp20_ = self->priv->m_workarea;
	_tmp21_ = _tmp20_.y;
	if (_tmp19_ < _tmp21_) {
		gint _tmp22_;
		GdkRectangle _tmp23_;
		gint _tmp24_;
		_tmp22_ = y;
		_tmp23_ = self->priv->m_workarea;
		_tmp24_ = _tmp23_.y;
		_tmp18_ = _tmp22_ > (_tmp24_ - 16);
	} else {
		_tmp18_ = FALSE;
	}
	if (_tmp18_) {
		GdkRectangle _tmp25_;
		gint _tmp26_;
		_tmp25_ = self->priv->m_workarea;
		_tmp26_ = _tmp25_.y;
		y = _tmp26_;
	}
	_tmp27_ = toplevel;
	gtk_window_get_size (_tmp27_, &_tmp28_, &_tmp29_);
	w = _tmp28_;
	h = _tmp29_;
	_tmp31_ = x;
	_tmp32_ = w;
	_tmp33_ = self->priv->m_workarea;
	_tmp34_ = _tmp33_.x;
	_tmp35_ = self->priv->m_workarea;
	_tmp36_ = _tmp35_.width;
	if ((_tmp31_ + _tmp32_) > (_tmp34_ + _tmp36_)) {
		gint _tmp37_;
		gint _tmp38_;
		GdkRectangle _tmp39_;
		gint _tmp40_;
		GdkRectangle _tmp41_;
		gint _tmp42_;
		_tmp37_ = x;
		_tmp38_ = w;
		_tmp39_ = self->priv->m_workarea;
		_tmp40_ = _tmp39_.x;
		_tmp41_ = self->priv->m_workarea;
		_tmp42_ = _tmp41_.width;
		_tmp30_ = (_tmp37_ + _tmp38_) < ((_tmp40_ + _tmp42_) + 16);
	} else {
		_tmp30_ = FALSE;
	}
	if (_tmp30_) {
		GdkRectangle _tmp43_;
		gint _tmp44_;
		GdkRectangle _tmp45_;
		gint _tmp46_;
		gint _tmp47_;
		_tmp43_ = self->priv->m_workarea;
		_tmp44_ = _tmp43_.x;
		_tmp45_ = self->priv->m_workarea;
		_tmp46_ = _tmp45_.width;
		_tmp47_ = w;
		x = (_tmp44_ + _tmp46_) - _tmp47_;
	}
	_tmp49_ = y;
	_tmp50_ = h;
	_tmp51_ = self->priv->m_workarea;
	_tmp52_ = _tmp51_.y;
	_tmp53_ = self->priv->m_workarea;
	_tmp54_ = _tmp53_.height;
	if ((_tmp49_ + _tmp50_) > (_tmp52_ + _tmp54_)) {
		gint _tmp55_;
		gint _tmp56_;
		GdkRectangle _tmp57_;
		gint _tmp58_;
		GdkRectangle _tmp59_;
		gint _tmp60_;
		_tmp55_ = y;
		_tmp56_ = h;
		_tmp57_ = self->priv->m_workarea;
		_tmp58_ = _tmp57_.y;
		_tmp59_ = self->priv->m_workarea;
		_tmp60_ = _tmp59_.height;
		_tmp48_ = (_tmp55_ + _tmp56_) < ((_tmp58_ + _tmp60_) + 16);
	} else {
		_tmp48_ = FALSE;
	}
	if (_tmp48_) {
		GdkRectangle _tmp61_;
		gint _tmp62_;
		GdkRectangle _tmp63_;
		gint _tmp64_;
		gint _tmp65_;
		_tmp61_ = self->priv->m_workarea;
		_tmp62_ = _tmp61_.y;
		_tmp63_ = self->priv->m_workarea;
		_tmp64_ = _tmp63_.height;
		_tmp65_ = w;
		y = (_tmp62_ + _tmp64_) - _tmp65_;
	}
	_tmp66_ = toplevel;
	_tmp67_ = x;
	_tmp68_ = y;
	gtk_window_move (_tmp66_, _tmp67_, _tmp68_);
	result = TRUE;
	_g_object_unref0 (toplevel);
	return result;
}


static gboolean
handle_real_draw (GtkWidget* base,
                  cairo_t* cr)
{
	Handle * self;
	gboolean result = FALSE;
	GdkWindow* _tmp0_;
	self = (Handle*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
	if (gtk_cairo_should_draw_window (cr, _tmp0_)) {
		GtkStyleContext* context = NULL;
		GtkStyleContext* _tmp1_;
		GtkStyleContext* _tmp2_;
		GtkAllocation allocation = {0};
		GtkAllocation _tmp3_ = {0};
		GtkStyleContext* _tmp4_;
		GtkAllocation _tmp5_;
		gint _tmp6_;
		GtkAllocation _tmp7_;
		gint _tmp8_;
		GtkAllocation _tmp9_;
		gint _tmp10_;
		GtkAllocation _tmp11_;
		gint _tmp12_;
		_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
		_tmp2_ = _g_object_ref0 (_tmp1_);
		context = _tmp2_;
		gtk_widget_get_allocation ((GtkWidget*) self, &_tmp3_);
		allocation = _tmp3_;
		_tmp4_ = context;
		_tmp5_ = allocation;
		_tmp6_ = _tmp5_.x;
		_tmp7_ = allocation;
		_tmp8_ = _tmp7_.y;
		_tmp9_ = allocation;
		_tmp10_ = _tmp9_.height;
		_tmp11_ = allocation;
		_tmp12_ = _tmp11_.width;
		gtk_render_handle (_tmp4_, cr, (gdouble) _tmp6_, (gdouble) (_tmp8_ + ((_tmp10_ - 40) / 2)), (gdouble) _tmp12_, 40.0);
		_g_object_unref0 (context);
	}
	result = FALSE;
	return result;
}


static void
handle_class_init (HandleClass * klass)
{
	handle_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (HandlePrivate));
	((GtkWidgetClass *) klass)->realize = (void (*) (GtkWidget*)) handle_real_realize;
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) handle_real_button_press_event;
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) handle_real_button_release_event;
	((GtkWidgetClass *) klass)->motion_notify_event = (gboolean (*) (GtkWidget*, GdkEventMotion*)) handle_real_motion_notify_event;
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) handle_real_draw;
	G_OBJECT_CLASS (klass)->finalize = handle_finalize;
	handle_signals[HANDLE_MOVE_BEGIN_SIGNAL] = g_signal_new ("move-begin", TYPE_HANDLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	handle_signals[HANDLE_MOVE_END_SIGNAL] = g_signal_new ("move-end", TYPE_HANDLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
handle_instance_init (Handle * self)
{
	self->priv = HANDLE_GET_PRIVATE (self);
}


static void
handle_finalize (GObject * obj)
{
	Handle * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HANDLE, Handle);
	G_OBJECT_CLASS (handle_parent_class)->finalize (obj);
}


GType
handle_get_type (void)
{
	static volatile gsize handle_type_id__volatile = 0;
	if (g_once_init_enter (&handle_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (HandleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) handle_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Handle), 0, (GInstanceInitFunc) handle_instance_init, NULL };
		GType handle_type_id;
		handle_type_id = g_type_register_static (gtk_event_box_get_type (), "Handle", &g_define_type_info, 0);
		g_once_init_leave (&handle_type_id__volatile, handle_type_id);
	}
	return handle_type_id__volatile;
}



